import GPUtil

# order- 确定返回可用 GPU 设备 ID 的顺序。order应指定为以下字符串之一：
# 'first'- 按升序排列可用的 GPU 设备 ID（默认）
# 'last'- 按 id 降序排列可用的 GPU 设备 id
# 'random'- 随机订购可用的 GPU 设备 ID
# 'load'- 按负载递增排序可用的 GPU 设备 ID
# 'memory'- 通过升序内存使用来排序可用的 GPU 设备 ID
# limit- 将返回的 GPU 设备 ID 数量限制为指定数量。必须是正整数。（默认 = 1）
# maxLoad- 被认为可用的 GPU 的最大当前相对负载。负载大于 的 GPUmaxLoad不会返回。（默认 = 0.5）
# maxMemory- 被视为可用的 GPU 的最大当前相对内存使用量。maxMemory不返回当前内存使用量大于的 GPU 。（默认 = 0.5）
# includeNan- 真/假标志，指示是否包括负载或内存使用为 NaN 的 GPU（指示无法检索使用情况）。（默认 = 假）
# excludeID- ID 列表，应从可用 GPU 列表中排除。见GPU类描述。（默认 = []）
# excludeUUIDexcludeID-除了它使用 UUID 之外，其他相同。（默认 = []）
# 输出
# deviceIDs - 所有可用 GPU 设备 ID 的列表。如果当前负载和内存使用量分别小于maxLoad和maxMemory，则认为 GPU 可用。该列表是根据 排序的order。返回的设备 ID 的最大数量由 限制limit。
def get_gpu_ids(content):
    deviceIDs = GPUtil.getAvailable(order=content["gpu"]["order"],
                                    limit=int(content["gpu"]["limit"]),
                                    maxLoad=float(content["gpu"]["maxLoad"]),
                                    maxMemory=float(content["gpu"]["maxMemory"]),
                                    includeNan=content["gpu"]["includeNan"],
                                    excludeID=content["gpu"]["excludeID"],
                                    excludeUUID=content["gpu"]["excludeUUID"])
    return deviceIDs
